/*
 *  function returns string containing contents of name object 
 *
 *    one argument: pi  - pointer to an item name object
 */

#include "fitypes.h"
#include "fifns.h"

char *fidump ( pFItemname pfi ) 
{  
   /* three chars needed for representation + null terminator (if octal) */
   char *result = (char *) malloc(4*sizeof(char));  

   if (getFIHasName(pfi)) {
      char itemname = getFIName(pfi);

      /* if printable ascii, show it as an ascii character */
      if ((itemname >= ' ') && (itemname <= '~')) {
          sprintf(result,"%c",itemname);
      } else {
          /* otherwise, dump to three-character octal */
          result[0]= 
             (char) 
                (((unsigned) '0') + ( (((unsigned) itemname) % 256) /64));
          result[1]= 
             (char) 
                (((unsigned) '0') + (((((unsigned) itemname) % 64) /8)));
          result[2]= 
             (char) 
                (((unsigned) '0') + (((unsigned) itemname) %8));
          result[3] = '\0';
      }
   } else {
      /* otherwise, if not named item, show paired brackets */
      strcpy(result,"<>");
   }
   return result;
}
