/*
 *  function allocates and initializes an item name object 
 *
 *    two arguments:
 *         hasName - flag showing if object has name
 *         name -    name of object (character) iff hasName is TRUE
 *
 *    value returned:  
 *        pointer to new name object
 *
 *    if allocation fails, routine prints error message and exits.
 */

#include <stdio.h>

#include "fitypes.h"
#include "fifns.h"

pFItemname fimake (char name, BOOLEAN hasName)
{   
   pFItemname pfi = (pFItemname) malloc(sizeof(FItemname));
   if (pfi == 0) {
      fprintf(stderr,"?? out of space failure in fimake\n");
      fprintf(stderr,"?? cannot make item name object\n");

      /*  if we can't allocate a few lousy bytes, that's bad  */
      exit(-1);
   }
   if (hasName) {
       putFIHasName(pfi);
       putFIName(pfi,name);
   } else {
       putFIIsNameless(pfi);
   }

   return(pfi);
}
