/*
 *  deallocate a list of character frequences 
 *
 *  Arguments:
 *
 *    pfl - pointer to first element in list
 *
 *  Outputs:  none
 *  Effects:  deallocates all items on list
 *
 *  Note:  
 *      item name and item count structures pointed to by members 
 *      of list not destroyed, because these structures are shared.
 *
 */

#include "fltypes.h"

#include "fcfns.h"
#include "fifns.h"
#include "flfns.h"

void fldestroy( pFList pfl )
{ 
  while (! isNilFL(pfl)) {
     pFList oldListHead = pfl;

     /*  free the list node proper; do not free constituent objects  */
     pfl = getFLNext(pfl);
     free(oldListHead);
  }
}
