/*  function definitions file:  pkg for init'ing list of char frequencies
 */

#ifndef FLFNS_HDR
#define FLFNS_HDR

#ifndef BASETYPES_HDR
#include  "basetypes.h"
#endif  /* BASETYPES_HDR */

#ifndef FLTYPES_HDR
#include  "fltypes.h"
#endif  /* FLTYPES_HDR */

#include <stdio.h>

/* 
 *  frequency count list access macros 
 *  note:  no distinction drawn between 
 *            objects that represent elements of frequency count lists
 *            objects that represent frequency count lists proper
 */

#define  isNilFL(pfl)            (pfl == nilFList)
#define  getFLNext(pfl)          ((pfl)->nextItem)
#define  getFLpOccCount(pfl)     ((pfl)->pOccCount)
#define  getFLpItemName(pfl)     ((pfl)->pItemName)
#define  getFLisNamedItem(pfl)   (isNamedItem(getFLpItemName(pfl)))
#define  getFLItemName(pfl)      (getItemName(getFLpItemName(pfl)))
#define  getFLFreqCt(pfl)        (getFCount(getFLpOccCount(pfl)))
#define  putFLNext(pfl,val)      ((pfl)->nextItem = val)
#define  putFLpOccCount(pfl,val) ((pfl)->pOccCount = (val))
#define  putFLpItemName(pfl,val) ((pfl)->pItemName = (val))
#define  putFLIsNamedItem(pfl)   (putIsNamedItem(getFLpItemName(pfl)))
#define  putFLUnNamedItem(pfl)   (putUnNamedItem(getFLpItemName(pfl)))
#define  putFLItemName(pfl,val)  (putItemName(getFLpItemName(pfl),val))
#define  putFLFreqCt(pfl)        (putFCount(getFLpOccCount(pfl),val))
                                 
/*  operators on frequency count lists  */
extern pFList    flinit( BOOLEAN (* getcIn) ( char *c, BOOLEAN *status ), 
                                                          BOOLEAN *status );
extern unsigned  fllength( pFList pfl );
extern void      fldestroy( pFList pfl );

#endif  /* FLFNS_HDR */
