/*
 *  function recursively deallocates a huffman code Tree
 *
 *   one argument:  name of tree to destroy
 *
 */

#include "httypes.h"

#include "htnfns.h"
#include "htfns.h"

     /* recursively destroy node, children of tree node */
static void htdestroy0 (pHTreeNode ptn)
{  
   if (! isNilHTNode(ptn)) {
      htdestroy0(getHTNLeft(ptn));   /* discard left subtree  */
      htdestroy0(getHTNRite(ptn));   /* discard right subtree */
      htndestroy(ptn);               /* discard root of tree  */
   }
}

     /* recursively deallocate nodes of tree, starting at root */
void htdestroy (pHTree pt) { htdestroy0(getHTRoot(pt)); }
