/*
 *  function deallocates node of a huffman code Tree
 *
 *   one argument:  pointer to node to destroy
 *
 *  note:  function not only deallocates tree, but all items pointed
 *         to by nodes of tree.  This would be a potential source of error
 *         if items in tree were shared at time of function's invocation.
 */

#include "htntypes.h"
#include "htnfns.h"

void htndestroy (pHTreeNode ptn)
{  
   if (! isNilHTNode(ptn)) {
      fidestroy(getHTNpItemName(ptn));    /* free allocated components */
      fcdestroy(getHTNpOccCount(ptn));
      free(ptn);                          /* finally, free the node itself */
   }
}
