/*  Huffman code tree node function definitions file */

#ifndef HTNFNS_HDR
#define HTNFNS_HDR

#ifndef HTNTYPES_HDR
#include  "htntypes.h"
#endif  /* HTNTYPES_HDR */

/*  access macros for Huffman tree node objects   */
#define  isNilHTNode(ptn)         ((ptn) == nilHTNode)
#define  getHTNLeft(ptn)          ((ptn)->leftChild)
#define  getHTNRite(ptn)          ((ptn)->rightChild)
#define  getHTNpOccCount(ptn)     ((ptn)->pOccCount)
#define  getHTNpItemName(ptn)     ((ptn)->pItemName)
#define  getHTNisNamedItem(ptn)   (getFIHasName(getHTNpItemName(ptn)))
#define  getHTNItemName(ptn)      (getFIName(getHTNpItemName(ptn)))
#define  getHTNFreqCt(ptn)        (getFCount(getHTNpOccCount(ptn)))
#define  putHTNLeft(ptn,val)      ((ptn)->leftChild = (val))
#define  putHTNRite(ptn,val)      ((ptn)->rightChild = (val))
#define  putHTNpOccCount(ptn,val) ((ptn)->pOccCount = (val))
#define  putHTNpItemName(ptn,val) ((ptn)->pItemName = (val))
#define  putHTNIsNamedItem(ptn)   (putFIHasName(getHTNpItemName(ptn)))
#define  putHTNUnNamedItem(ptn)   (putFIIsNameless(getHTNpItemName(ptn)))
#define  putHTNItemName(ptn,val)  (putFIName(getHTNpItemName(ptn),val))
#define  putHTNFreqCt(ptn)        (putFCount(getHTNpOccCount(ptn),val))

/*  operators on Huffman tree nodes  */
extern pHTreeNode htnmake ( pFItemname pni,pFCount pfc, BOOLEAN *status);
extern pHTreeNode htnjoin ( pHTreeNode pn1, pHTreeNode pn2, BOOLEAN *status );
extern BOOLEAN    htnodedump ( pHTreeNode pt, unsigned fldwidth );
extern void       htndestroy ( pHTreeNode phtn );

#endif  /* HTNFNS_HDR */
