/*
 *  function updates priority queue by placing priority queue element 
 *  at first free position at end of queue, and then sifting it up.
 *
 *  [Note:  for this implementation, the weights that drive the sifting 
 *  are assumed to be encoded in the items proper.]
 *
 *    3 arguments:  q      - a pointer to a priority queue
 *                  pitem  - pointer to an item to add to the queue--
 *                           here, a Huffman code tree
 *
 *    value returned:  TRUE iff insertion into priority queue succeeded
 */

#include "pqtypes.h"
#include "pqfns.h"

BOOLEAN pqadd ( pPriQ q, pHTree pitem )
{  
   if (! pqputatend(q, pitem)) return(FALSE);

   pqsiftup(q, getPriQmaxidx(q));
   return(TRUE);
}
