/*
 *  function dumps contents of priority queue to standard output
 *
 *    one argument:  q   - a pointer to a priority queue
 */

#include <stdio.h>

#include "pqtypes.h"
#include "pqfns.h"

void pqdump ( pPriQ q ) 
{  
   unsigned min_idx = getPriQminidx(q);
   unsigned max_idx = getPriQmaxidx(q);

   printf("queue capacity, no. queue elts. = %d, %d\n", 
                               getPriQcap(q), max_idx-min_idx+1);

   { unsigned eltix;      /* no. of element in queue to print next */
     int linidx;          /* no. of queue elts on current line of output */
     int perline = 5;     /* no. of queue elts to pack on one output line */

     printf("contents of queue: \n");
 
     for (eltix = min_idx; eltix <= max_idx;  ) {
        for (linidx=0; (linidx<perline) && (eltix<=max_idx); linidx++,eltix++)
            pqeltdump( getPriQelt(q,eltix) );
        if (linidx != 0) printf("\n");
     }
   }
}
