/*
 *  function dumps info about a priority queue element to standard output
 *
 *   one argument:  qe  - a pointer to a priority queue element
 *
 *   note: name of root node in each Huffman code tree 
 *         treated as name of tree for display purposes
 */

#include <stdio.h>

#include "pqtypes.h"

#include "fcfns.h"
#include "fifns.h"
#include "htnfns.h"
#include "htfns.h"
#include "pqfns.h"

void pqeltdump ( pPriQElt qe ) 
{  
   if (getHTNisNamedItem(getPQElt(qe))) {

       /* treat name of tree's root as name of item */
       char *itName = fidump(getHTNpItemName(getHTRoot(getPQElt(qe))));

       printf("name=%s, wt %d //", itName, getPQEltPri(qe));
       free(itName);

   } else {
       printf("unnamed, wt %d //", getPQEltPri(qe));
   }
}
