/*
 *  function puts priority queue element at first free position at end of
 *  queue -- i.e., at queue's end -- and adjusts queue's bookkeeping variables.
 *
 *    2 arguments:  q       - a pointer to a priority queue
 *                  pHTree  - item to put at end
 *
 *    value returned:  TRUE iff insertion into priority queue succeeded
 */

#include <stdio.h>

#include "basetypes.h"

#include "pqtypes.h"
#include "pqfns.h"

BOOLEAN pqputatend ( pPriQ q, pHTree pt)
{  
   if (isFullPriQ(q)) return(FALSE);

   { pPriQElt qe = (pPriQElt) malloc(sizeof(PriQElt));
     
     if (qe == 0) {
        fprintf(stderr,"out of space error in pqputatend");
        return(FALSE);
     }

     putPQElt(qe,pt);
     putPriQelt(q,getPriQffree(q),qe); 
     putPriQffree(q,getPriQffree(q)+1);

     return(TRUE);
   }
}
