/*
 *  function sifts Huffman code tree object in priority queue at index idx 
 *  down to acceptable level in queue, repeatedly swapping it until it
 *  reaches the top of the queue, or resides below a parent of equal
 *  or lesser weight.
 *
 *    two arguments:  q   - a pointer to a priority queue
 *                    idx - index of element to sift down
 */

#include "pqtypes.h"

#include "fcfns.h"
#include "htnfns.h"
#include "htfns.h"
#include "pqfns.h"

void pqsiftdn ( pPriQ q, unsigned idx ) 
{
   if (lteqPriQ(q,getLidx(idx),getRidx(idx))) {
        if (! lteqPriQ(q,idx,getLidx(idx))) {
            /* swap elements */
            swapPriQelt(q,idx,getLidx(idx));

            /* continue siftdown */
            pqsiftdn (q, getLidx(idx));
      }
   }
   else if (! lteqPriQ(q,idx,getRidx(idx))) {
      /* swap elements */
      swapPriQelt(q,idx,getRidx(idx));

      /* continue siftdown */
      pqsiftdn (q, getRidx(idx));
   }
}
