/*
 *  function sifts Huffman code tree object in priority queue at index idx 
 *  down to acceptable level in queue, repeatedly swapping it until it
 *  reaches the top of the queue, or resides below a parent of equal
 *  or lesser weight.
 *
 *    two arguments:  q   - a pointer to a priority queue
 *                    idx - index of element to sift up
 *
 */

#include "pqtypes.h"

#include "fcfns.h"
#include "htnfns.h"
#include "htfns.h"
#include "pqfns.h"

void pqsiftup ( pPriQ q, unsigned idx ) 
{  
   if (! lteqPriQ(q,getParentidx(idx),idx)) {
      /* swap elements */
      swapPriQelt(q,getParentidx(idx),idx); 

      /* continue, as needed */
      pqsiftup(q,getParentidx(idx));
   }
}
