/*  priority queue type definitions header file  */

#ifndef PQTYPES_HDR
#define PQTYPES_HDR

#ifndef BASETYPES_HDR
#include  "basetypes.h"
#endif  /* BASETYPES_HDR */

#ifndef HTTYPES_HDR
#include  "httypes.h"
#endif  /* HTTYPES_HDR */

/*
 *  object containing the elements of a priority queue 
 */
typedef struct {
   pHTree huffTree;   /* the objects in this priQ are Huffman code trees */
   /*
    *  no second "priority" field needed for this priority queue: 
    *  the q elt. priorities--i.e., the char counts--
    *      are stored in the roots of the Huffman code tree
    */
} PriQElt, *pPriQElt, **ppPriQElt;

/*
 *  priority queue object:  priority queue data + bookkeeping 
 */
typedef struct {
    ppPriQElt ptrQ;        /* array representing queue */
    unsigned capacity;     /* number of elements in queue     */
    unsigned ffree;        /* index of first free element in queue  */
} PriQ, *pPriQ;

#define nilPriQ       ((pPriQ) 0)

#endif  /* PQTYPES_HDR */
