/*
 *  dispose of a worklist of Huffman tree nodes headed by pwl
 *  note that dynamically allocated Huffman tree nodes pointed to
 *    by list aren't disposed, since these tree nodes are shared
 *
 */

#include "wltypes.h"
#include "wlfns.h"

void wldestroy( pWList pwl )
{
   pWList this_rec = pwl;
   pWList next_rec;

   while (! isNilWL(this_rec)) {
      next_rec = getWLNext(this_rec);
      free(this_rec);
      this_rec = next_rec;
   }
}
