/*
 *  function allocates and initializes a Huffman code tree node worklist item
 *    that initially points to a caller-specified huffman code tree node
 *    that initially points to a nil next item
 *  
 *    if allocation fails, routine prints error message and exits.
 */

#include <stdio.h>

#include "httypes.h"
#include "wltypes.h"

#include "wlfns.h"

pWList wlmake ( pHTreeNode phtn )
{   
   pWList pwl = (pWList) malloc(sizeof(WList));

   if (pwl == 0) {
      fprintf(stderr,"?? out of space failure in wlmake\n");
      fprintf(stderr,"?? cannot make work list item object\n");

      /*  if we can't allocate a few lousy bytes, that's bad  */
      exit(-1);
   }

   putWLTreeNode(pwl,phtn);
   putWLNext(pwl,nilWL);
 
   return pwl;
}
